
% ԃ}V`
% trans(ԁCANV/Cxg, I, Jږ)
% [vo邽߂ɑJږ̓j[Nɕt邱

trans(notape, insert, stopping, t1).
trans(stopping, eject, notape, t2).
trans(stopping, play, playing, t3).
trans(playing, eject, notape, t4).
trans(playing, stop, stopping, t5).
trans(playing, rw, rewinding, t6).
trans(playing, rw, forwarding, t7).
trans(playing, pause, pausing, t8).
trans(rewinding, eject, notape, t9).
trans(rewinding, stop, stopping, t10).
trans(rewinding, play, playing, t11).
trans(rewinding, ff, forwarding, t12).
trans(forwarding, eject, notape, t13).
trans(forwarding, stop, stopping, t14).
trans(forwarding, play, playing, t15).
trans(forwarding, rw, rewinding, t16).
trans(pausing, eject, notape, t17).
trans(pausing, stop, stopping, t18).
trans(pausing, pause, playing, t19).
trans(pausing, play, playing, t20).

cost(default, 1).
cost(insert, 5).
cost(play, 8).
cost(eject, 3).
cost(stop, 3).
cost(rw, 3).
cost(pause, 3).
cost(ff, 3).

% TvO
% Path́CAԂZԂւ̌oH
% gp: path(notape, nptape, X).

path( A, Z, Path, Cost)  :-
  path1( A, [Z], 0, Path, [], [], Cost).

% path1( A, [A | Path1], Cost, TPath, TPath, APath, Cost ).  % return transition path
path1( A, [A | Path1], Cost, APath, TPath, APath, Cost ).  % return action/event path

path1( A, [Y | Path1], Cost1, Path, TPath, APath, Cost)  :-
  trans( X, Act, Y, T),
  not( member( T, TPath) ),         % No-cycle condition
  cost(Act, CostXY),
  Cost2 is Cost1 + CostXY,
  path1( A, [X, Y | Path1], Cost2, Path, [T | TPath], [Act|APath], Cost).

pathMax(A, Z, Path, Max) :-
  path(A, Z, Path, M), M >= Max.

maxPath(A, Z, Max, PathList) :-
  findall(Exe, path(A, Z, Path1, Exe), L),
  max_list(L, Max),
  findall(Path2, pathMax(A, Z, Path2, Max), PathList),
  write(PathList), nl.
  
max_list([X], X).
max_list([X|L], M) :-
        max_list(L, M1), 
        M is max(X, M1).

%------ ȉCJ
maxPath3(A, Z, Max) :-
  findall([Exe, Path1], path(A, Z, Path1, Exe), L),
  write(L), nl,
  max_list2(L, Max).
  
minPath(A, Z, Path, Min) :-
  path(A, Z, Path, Min), path(A, Z, _, C), Min =< C.

not2(A, B) :- not(A); not(B).


max_list2([X], X) :- write(X), nl.
max_list2([X|L], M) :-
        max_list2(L, M1), 
       % M is max(X, M1).
        first(X, Xf), first(M1, M1f), 
        write(Xf< M1f),
       (Xf > M1f, M is X; Xf <= M1f, M is M1).


first([X|_], X).

